
#include "string_set_classes.h"

StringSet::~StringSet() {}

/* YOUR CODE HERE */

class StringList {
public:
  StringList(string,StringList*);
  ~StringList(); // deletes tail and pointed to string (so no sharing!)
  string head;
  StringList * tail;
};

StringList::StringList(string s, StringList *t) : head(s), tail(t) {}

StringList::~StringList() {
  if(tail)
    delete tail;
}

StringSetList::StringSetList() : elts(NULL) {}

StringSetList::~StringSetList() {
  if(elts)
    delete elts;
}

bool StringSetList::member(string s) {
  for(StringList * lst = elts; lst != NULL; lst = lst->tail)
    if(lst->head.compare(s)==0)
      return true;
  return false;
}

void StringSetList::add(string s) {
  if(member(s))
    return;
  StringList * new_lst = new StringList(s,elts);
  elts = new_lst;
}

void StringSetList::foreach(StringDoer * d) {
  for(StringList * lst = elts; lst != NULL; lst = lst->tail)
    d->f(lst->head);
}
