
#include <iostream>
#include "string_set_classes.h"

void many_member_tests(int how_many, StringSet * set, string str) {
  while(--how_many)
    set->member(str);
}

void add_several(StringSet * set) {
  set->add("a");
  string s = "d";
  for(int i=0; i < 100; ++i) {
    ++s[0]; // turn 'd' into 'e' into 'f' ... 100 times (not all English)
    set->add(s);
  }
  set->add("b");
}

void tests(int which_test) {
  StringSet *s1 = new StringSetArray();
  StringSet *s2 = new StringSetList();
  add_several(s1);
  add_several(s2);
 
  switch(which_test) {
  case 1:
    cout << "test 1" << endl;
    many_member_tests(1000000, s1, "a");
    break;
  case 2:
    cout << "test 2" << endl;
    many_member_tests(1000000, s2, "a");
    break;
  case 3:
    cout << "test 3" << endl;
    many_member_tests(1000000, s1, "b");
    break;
  case 4:
    cout << "test 4" << endl;
    many_member_tests(1000000, s2, "b");
    break;
  case 5:
    cout << "test 5" << endl; 
    many_member_tests(1000000, s1, "c");
    break;
  case 6:
    cout << "test 6" << endl; 
    many_member_tests(1000000, s2, "c");
    break;
  default: break;
  }

  delete s1;
  delete s2;
}

int main(int argc, char** argv) {
  tests(atoi(argv[1]));
}
